#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var program = require("commander");
program
    .option('-c, --ci', 'Run in CI')
    .option('-h, --hook', 'Run on commit hook')
    .parse(process.argv);
var location = program.ci ? 'ci' : 'local';
process.env.COMMIT_HOOK = program.hook;
var runCommitLint = require("./lint-commits." + location).default;
runCommitLint().catch(function (error) {
    console.error(error);
    process.exit(1);
});
//# sourceMappingURL=cli.js.map