"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var config = require("@commitlint/config-conventional");
var core_1 = require("@commitlint/core");
var isIgnored = require("@commitlint/is-ignored");
var SemanticReleaseError = require("@semantic-release/error");
var path = require("path");
var util_1 = require("./util");
function verifyRelease(repoData, data) {
    return validateCommits(data.commits);
}
exports.verifyRelease = verifyRelease;
function validateCommits(commits) {
    return __awaiter(this, void 0, void 0, function () {
        var opts, semanticCommitlintConfig, customLintFunctions;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, core_1.load(config)];
                case 1:
                    opts = _a.sent();
                    return [4 /*yield*/, util_1.getSemanticCommitlintConfig()];
                case 2:
                    semanticCommitlintConfig = _a.sent();
                    customLintFunctions = getCustomLintFunctions(semanticCommitlintConfig);
                    return [4 /*yield*/, Promise.all(commits.map(function (commit) { return validateCommit(commit, opts, customLintFunctions); }))];
                case 3:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.validateCommits = validateCommits;
function validateCommit(commitMeta, opts, customLintFunctions) {
    return __awaiter(this, void 0, void 0, function () {
        var report, detail, formated;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, core_1.lint("" + commitMeta.message, opts.rules, opts.parserPreset ? { parserOpts: opts.parserPreset.parserOpts } : {})];
                case 1:
                    report = _a.sent();
                    customLintFunctions.forEach(function (customLintFunction) {
                        if (isIgnored(commitMeta.message)) {
                            return;
                        }
                        customLintFunction(commitMeta.message, report);
                    });
                    if (!report.valid) {
                        detail = commitMeta.commit.short ? " " + commitMeta.commit.short : '';
                        console.error('😞   Errors found with commit' + detail);
                        console.error("\uD83D\uDCAC   " + commitMeta.message);
                        formated = core_1.format({ errors: report.errors });
                        formated.forEach(function (item) { return console.log(item); });
                        throw new SemanticReleaseError("The commit message is not formatted correctly", 'EINVALIDCOMMIT');
                    }
                    return [2 /*return*/];
            }
        });
    });
}
function getCustomLintFunctions(_a) {
    var lintFunctions = _a.lintFunctions;
    if (lintFunctions === undefined) {
        return [];
    }
    return lintFunctions.map(requireRelative);
}
function requireRelative(relativePath) {
    return require(path.resolve(relativePath));
}
//# sourceMappingURL=lint-commits.plugin.js.map